<!DOCTYPE html>
<html layout:decorate="~{fragments/layout}">

<head>
	<title>Variant API</title>
</head>
<div layout:fragment="content">

	<body>
		<h1>Index Variant API</h1>
		<div>
			<button onclick="openModal()" class="btn btn-primary mb-2">Create</button>
		</div>
		<div id="isiData"></div>

		<script>
			$(function () {
				getAllVariant()
			})
			function getAllVariant() {
				$.ajax({
					url: '/api/variant',
					type: 'get',
					contentType: 'application/json',
					success: function (response) {
						listView(response)
					}
				})
			}
			function listView(response) {
				var str = '<table class="table table-hover table-striped" border="1">'
				str += '<thead class="thead-dark">'
				str += '<tr>'
				str += '<th class="text-center">No</th>'
				str += '<th class="text-center">Category ID</th>'
				str += '<th class="text-center">Variant Initial</th>'
				str += '<th class="text-center">Variant Name</th>'
				str += '<th class="text-center">is Active</th>'
				str += '<th class="text-center" colspan="2">Action</th>'
				str += '</tr>'
				str += '</thead>'
				str += '<tbody>'
				for (var i = 0; i < response.length; i++) {
					str += '<tr>'
					str += '<td>' + (i + 1) + '</td>'
					str += '<td>' + response[i].category.categoryName + '</td>'
					str += '<td>' + response[i].variantInitial + '</td>'
					str += '<td>' + response[i].variantName + '</td>'
					var checked = response[i].isActive ? 'checked' : ''
					str += '<td><input type="checkbox" disabled ' + checked + '></td>'
					str += '<td><button class="btn btn-warning" value="' + response[i].id + '"onClick="f_edit(value)">Edit</button></td>'
					str += '<td><button class="btn btn-danger" value="' + response[i].id + '"onClick="f_delete(value)">Delete</button></td>'
					str += '</tr>'

				}

				str += '</tbody>'
				str += '</table>'


				$('#isiData').empty()
				$('#isiData').html(str)
			}

			function openModal() {
				$.ajax({
					url: '/api/category',
					type: 'get',
					contentType: 'application/json',
					success: function (category) {
						var str = "<form>"
						str += '<div class="form-group">'
						str += '<label>Category Name</label>'
						str += '<select class="form-control" id="categoryId">'
						for (var i = 0; i < category.length; i++) {
							str += '<option value="' + category[i].id + '">' + category[i].categoryName + '</option>'
						}
						str += '</select>'
						str += '</div>'
						str += '<div class="form-group">'
						str += '<label>Variant Initial</label>'
						str += '<input type="text" class="form-control" id="variantInitial">'
						str += '</div>'
						str += '<div class="form-group">'
						str += '<label for="variantName">Variant Name</label>'
						str += '<input type="text" class="form-control" id="variantName">'
						str += '</div>'
						str += '<div class="form-group form-check">'
						str += '<input type="checkbox" class="form-check-input" id="isActive" checked>'
						str += '<label for="isActive">Is Active</label>'
						str += '</div>'
						str += "</form>"

						$(".modal-title").html("Form Variant")
						$(".modal-body").html(str)
						$("#btnSave").html("Save Date")
						$("#btnSave").off('click').on('click', saveVariant)
						$("#modal").modal('show')
					}
				})

			}
			function saveVariant() {
				var formdata = '{'
				formdata += '"categoryId":"' + $("#categoryId").val() + '",'
				formdata += '"variantInitial":"' + $("#variantInitial").val() + '",'
				formdata += '"variantName":"' + $("#variantName").val() + '",'
				formdata += '"isActive":' + $("#isActive")[0].checked + ''
				formdata += '}'

				$.ajax({
					url: '/api/variant/add',
					data: formdata,
					type: 'post',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						getAllVariant();
					}
				})
			}
			function f_edit(id) {
				$.ajax({
					url: '/api/variant/' + id,
					type: 'get',
					contentType: 'application/json',
					success: function (variant) {
						$.ajax({
							url: '/api/category',
							type: 'get',
							contentType: 'application/json',
							success: function (category) {
								var str = '<form>'
								str += '<div class="form-group">'
								str += '<label>Category Name</label>'
								str += '<select class="form-control" id="categoryId">'
								for (var i = 0; i < category.length; i++) {
									var selected = variant.categoryId == category[i].id ? 'selected' : ''
									str += '<option value="' + category[i].id + '" ' + selected + '>' + category[i].categoryName + '</option>'
								}
								str += '</select>'
								str += '</div>'
								str += '<div class="form-group">'
								str += '<label for="variantInitial">Variant Initial</label>'
								str += '<input type="text" class="form-control" id="variantInitial" value=" ' + variant.variantInitial + ' ">'
								str += '</div>'
								str += '<div class="form-group">'
								str += '<label for="variantName">Variant Name</label>'
								str += '<input type="text" class="form-control" id="variantName" value=" ' + variant.variantName + '">'
								str += '</div>'
								str += '<div class="form-group form-check">'
								var checked = variant.isActive ? 'checked' : ''
								str += '<input type="checkbox" class="form-check-input" id="isActive" ' + checked + ' >'
								str += '<label for="isActive">Is Active</label>'
								str += '</div>'
								str += '</form>'

								$(".modal-title").html("Edit Variant")
								$(".modal-body").html(str)
								$("#btnSave").html("Save Data")
								//$("#btnSave").off('click').on("click", updateVariant)
								$("#btnSave").off('click').on('click',
									function () {
										updateVariant(id)
									})
								$("#modal").modal('show')
							}
						})
					}
				})
			}
			
			function updateVariant(id){
				var formdata = '{'
				formdata += '"categoryId":"' + $("#categoryId").val() + '",'
				formdata += '"variantInitial":"' + $("#variantInitial").val() + '",'
				formdata += '"variantName":"' + $("#variantName").val() + '",'
				formdata += '"isActive":' + $("#isActive")[0].checked + ''
				formdata += '}'
				
				$.ajax({
					url: '/api/variant/edit/' + id,
					data: formdata,
					type: 'put',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						getAllVariant();
					}
				})
			}
			function f_delete(id) {
				$.ajax({
					url: '/api/variant/' + id,
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = '<h4>Apakah kamu yakin ingin menghapus data ini ?</h4>'
						str += '<center><b> Variant Initial</b> : ' + data.variantInitial + '</center>'
						str += '<center><b> Variant Name</b> : ' + data.variantName + '</center>'
						str += '<center><b> Category</b> : ' + data.category.categoryName + '</center>'

						$(".modal-title").html("Delete Variant")
						$(".modal-body").html(str)
						$("#btnSave").off('click').on('click',
							function () {
								deleteVariant(id)
							})
							$("#modal").modal('show')
					}
				})
			}
			function deleteVariant(id){
				$.ajax({
					url: '/api/variant/delete/' + id,
					type: 'put',
					contentType: 'application/json',
					success: function(){
						$("#modal").modal('toggle')
						getAllVariant()
					}
				})
			}
		</script>

	</body>
</div>

</html>